#include <stdio.h>
#include <stdlib.h>

#define MAXN 200000

int positions[2][MAXN];								// Stores the positions of the points
int n;												// The number of the points
int sorted[2][MAXN];								// sorted[0] stores the indexes of the points sorted by the 
													// first coordinate, sorted[1] sorted by the second
int result[MAXN][3];
int result_sz = 0;
char *inputFile, *outputFile;
int pos, dir, count;

// Calculate the XOR sum of the current situation
int CalcXORSum()
{
	int i = 0;
	int j;
	int sum = 0;

	if (n % 2 == 0) i = 1;

	for (j = i;j < n;j += 2)
	{
		int tmp = positions[0][sorted[0][j]] - 1;
		if (j > 0) tmp -= positions[0][sorted[0][j - 1]];
		if (tmp  < 0)
			printf("sdgsd");
		sum ^= tmp;

		tmp = positions[1][sorted[1][j]] - 1;
		if (j > 0) tmp -= positions[1][sorted[1][j - 1]];
		if (tmp  < 0)
			printf("sdgsd");
		sum ^= tmp;
	}

	return sum;
}

// Compare function for sorting the points by the first coordinate
int cmpx(const void *a, const void *b)
{
	return positions[0][*((int*)a)] - positions[0][*((int*)b)];
}

// Compare function for sorting the points by the second coordinate
int cmpy(const void *a, const void *b)
{
	return positions[1][*((int*)a)] - positions[1][*((int*)b)];
}

void Check()
{
	int sum;

	sum = CalcXORSum();

	if (sum == 0){/* printf("OK!\n");*/}
	else
	{
		printf("0\nWRONG: The move is not winning\n");
		exit(0);
	}
}


void Init()
{
	int i;

	freopen(inputFile, "rt", stdin);
	scanf("%d", &n);

	for (i = 0;i < n;i++)
	{
		scanf("%d%d", &positions[0][i], &positions[1][i]);
		sorted[0][i] = sorted[1][i] = i;
	}

	// Sort the points by first and second coordinate
	qsort(sorted[0], n, sizeof(sorted[0][0]), cmpx);
	qsort(sorted[1], n, sizeof(sorted[1][0]), cmpy);

	freopen(outputFile, "rt", stdin);

	if (scanf("%d %d %d", &pos, &dir, &count) != 3)
	{
		printf("0\nWRONG: Invalid output format!!!\n");
		exit(0);
	}

	if (! (pos >= 1 && pos <= n))
	{
		printf("0\nWRONG: Invalid ID of the piece\n");
		exit(0);
	}
	pos--;

	if (! (dir == 1 || dir == 2))
	{
		printf("0\nWRONG: Invalid direction of the move\n");
		exit(0);
	}
	dir--;

	if (count <= 0 || count >= positions[dir][pos])
	{
		printf("0\nWRONG: Invalid length of the move\n");
		exit(0);
	}

	if (sorted[dir][0] == pos)
	{
		if (positions[dir][sorted[dir][0]] - count <= 0)
		{
			printf("0\nWRONG: The move goes outside the table\n");
			exit(0);
		}
	}
	else
	{
		for (int i = 1;i < n;i++)
			if (sorted[dir][i] == pos)
			{
				if (positions[dir][sorted[dir][i]] - count <= positions[dir][sorted[dir][i - 1]])
				{
					printf("0\nWRONG: The move passes through an occupied column or row\n");
					exit(0);
				}
				break;
			}
	}

	positions[dir][pos] -= count;
	Check();
}

int main(int argc, char* args[])
{
	if (argc < 2)
	{
		printf("0\nUsage: checker input_file output_file\n");
		return 0;
	}

	inputFile = args[1];
	outputFile = args[2];

	Init();
//	Check();
	printf("10\nOK!\n");
	return 0;
}
